import { Component, component } from "@rbxts/matter"
import { transform } from "./defaults"
import type { 
    Model as ModelComponent,
    Transform as TransformComponent,
    Health as HealthComponent,
    Damage as DamageComponent,
    PlayerCharacter as PlayerCharacterComponent,
    Lifetime as LifetimeComponent
} from "./types"

export type GooplerComponentType = 
    | ModelComponent
    | TransformComponent
    | HealthComponent
    | DamageComponent
    | PlayerCharacterComponent
    | LifetimeComponent

export type GooplerComponent = Component<GooplerComponentType>

/**
 * The {@link ModelComponent | Model} component constructor.
 */
export const Model = component<ModelComponent>("Model")

/**
 * The {@link TransformComponent | Transform} component constructor.
 */
export const Transform = component<TransformComponent>("Transform", transform)

/**
 * The {@link HealthComponent | Health} component constructor.
 */
export const Health = component<HealthComponent>("Health")

/**
 * The {@link DamageComponent | Damage} component constructor.
 */
export const Damage = component<DamageComponent>("Damage")

/**
 * The {@link PlayerCharacterComponent | PlayerCharacter} component constructor.
 */
export const PlayerCharacter = component<PlayerCharacterComponent>("PlayerCharacter")

/**
 * The {@link LifetimeComponent | Lifetime} component constructor.
 */
export const Lifetime = component<LifetimeComponent>("Lifetime")

/**
 * This is a test component constructor.
 *
 * It shouldn't be used and should be removed at some point.
 */
export const Test = component("Test")