import { World, useEvent } from "@rbxts/matter"
import { StarterGui } from "@rbxts/services"
import { ClientState } from "ReplicatedStorage/ecs/state"
import { getEvent } from "ReplicatedStorage/remotes"

const resetButtonCallback = new Instance("BindableEvent")
StarterGui.SetCore("ResetButtonCallback", resetButtonCallback)

getEvent("resetButton")

function customReset(_: World, _client: ClientState): void {
    const resetButtonEvent = getEvent("resetButton")
    for (const [,] of useEvent(resetButtonCallback, "Event")) {
        resetButtonEvent.FireServer()
    }
}

export = customReset