import { World, useEvent } from "@rbxts/matter"
import { Players } from "@rbxts/services"
import { PlayerCharacter } from "ReplicatedStorage/ecs/components"
import { getEvent } from "ReplicatedStorage/remotes"

function toolHandler(world: World): void {
    const activateToolEvent = getEvent("activateToolEvent")
    
    for (const [_, character] of world.query(PlayerCharacter)) {
		if (!character.equippedTool) continue

        for (const [_] of useEvent(character.equippedTool, "Activated")) {
            print(Players.LocalPlayer.GetMouse())
            activateToolEvent.FireServer(
                Players.LocalPlayer.GetMouse().Hit.Position
            )
        }
	}
}

export = toolHandler