import Roact from "@rbxts/roact"

interface paddingProps extends Roact.JsxInstanceProperties<UIPadding> {
	padding?: UDim | Roact.Binding<UDim>
	paddingX?: UDim | Roact.Binding<UDim>
	paddingY?: UDim | Roact.Binding<UDim>

	Event?: Roact.JsxInstanceEvents<UIPadding>
	Change?: Roact.JsxInstanceChangeEvents<UIPadding>
}

function padding(props: paddingProps): Roact.Element {
	const { padding, paddingX, paddingY } = props

	const spreadableProps = { ...props } as Partial<paddingProps>
	delete spreadableProps.padding
	delete spreadableProps.paddingX
	delete spreadableProps.paddingY

	return (
		<uipadding
			{...spreadableProps}
			PaddingBottom={paddingY ?? padding}
			PaddingTop={paddingY ?? padding}
			PaddingLeft={paddingX || padding}
			PaddingRight={paddingX || padding}
		/>
	)
}

export default padding